// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "../Asset.hpp"
#include "../AssetLoader.hpp"

namespace Dawn {
  enum NewTrueTypeAssetState {
    NEW_TRUE_TYPE_ASSET_STATE_INITIAL,
    NEW_TRUE_TYPE_ASSET_STATE_OPEN,
    // NEW_TRUE_TYPE_ASSET_STATE_LOAD_RAW,
    NEW_TRUE_TYPE_ASSET_STATE_VALIDATE_HEADER,
    NEW_TRUE_TYPE_ASSET_STATE_VALIDATE_VERSION,
    NEW_TRUE_TYPE_ASSET_STATE_READ_VARIANT_COUNT,
  }

  class NewTrueTypeAsset : public Asset {
    protected:
      AssetLoader loader;
      enum NewTrueTypeAssetState state = NEW_TRUE_TYPE_ASSET_STATE_INITIAL;

    public:
      NewTrueTypeAsset(AssetManager *assMan, std::string name);
      void updateSync() override;
      void updateAsync() override;
      ~NewTrueTypeAsset();
  };
}