// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "NewTrueType.hpp"

using namespace Dawn;

NewTrueType::NewTrueType(FontManager *fontMan) {
  assertNotNull(fontMan);
  this->fontManager = fontMan;
}

void NewTrueType::addStyle(flag_t style) {
  assertTrue(this->faces.find(style) == this->faces.end());

  //Create the face
  this->faces[style] = new NewTrueTypeFace();
}

NewTrueType::~NewTrueType() {
  auto it = this->faces.begin();
  while(it != this->faces.end()) {
    delete it->second;
    it++;
  }
}