// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "NewTrueTypeFace.hpp"
#include "display/font/FontManager.hpp"

namespace Dawn {
  class NewTrueType {
    protected:
      std::map<flag_t, NewTrueTypeFace*> faces;
      FontManager *fontManager;

    public:
      NewTrueType(FontManager *fontMan);
      void addStyle(flag_t style);
      NewTrueTypeFace * getFace(flag_t style);
      ~NewTrueType();

      friend class NewTrueTypeFace;
  };
}