// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"

namespace Dawn {
  struct VNSetEvent {
    std::string property = "";
    std::string to = "";
    std::string from = "";
    std::string duration = "";
    std::string curve = "";
    std::string type = "";
  };

  class VNSetEventParser : public XmlParser<struct VNSetEvent> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNSetEvent *out,
        std::string *error
      ) override;
  };
}